install_headers.sh 2.5 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586
  1. #!/bin/sh
  2. # Parameters:
  3. # $1 = source dir
  4. # $2 = dst dir
  5. # $top_builddir = well you guessed it
  6. die_if_not_dir()
  7. {
  8. for dir in "$@"; do
  9. test -d "$dir" && continue
  10. echo "Error: '$dir' is not a directory"
  11. exit 1
  12. done
  13. }
  14. # Ensure that created dirs/files have 755/644 perms
  15. umask 022
  16. # Sanity tests
  17. die_if_not_dir "$1"
  18. mkdir -p "$2" 2>/dev/null
  19. die_if_not_dir "$2"
  20. die_if_not_dir "$top_builddir"
  21. if ! test -x "$top_builddir/extra/scripts/unifdef"; then
  22. echo "Error: need '$top_builddir/extra/scripts/unifdef' executable"
  23. exit 1
  24. fi
  25. # Sanitize and copy uclibc headers
  26. (
  27. # We must cd, or else we'll prepend "$1" to filenames!
  28. cd "$1" || exit 1
  29. find ! -name '.' -a ! -path '*/.*'
  30. ) | \
  31. (
  32. IFS=''
  33. while read -r filename; do
  34. filename="${filename#./}"
  35. if test -d "$1/$filename"; then
  36. mkdir -p "$2/$filename" 2>/dev/null
  37. else
  38. "$top_builddir/extra/scripts/unifdef" -UUCLIBC_INTERNAL "$1/$filename" >"$2/$filename" || exit
  39. fi
  40. done
  41. )
  42. # Just copy (no sanitization) some kernel headers.
  43. eval `grep ^KERNEL_HEADERS "$top_builddir/.config"`
  44. if ! test -d "$KERNEL_HEADERS/asm" \
  45. || ! test -d "$KERNEL_HEADERS/asm-generic" \
  46. || ! test -d "$KERNEL_HEADERS/linux" \
  47. ; then
  48. echo "Error: '$KERNEL_HEADERS' is not a directory containing kernel headers."
  49. echo "Check KERNEL_HEADERS= in your .config file."
  50. exit 1
  51. fi
  52. # NB: source or target files and directories may be symlinks,
  53. # and for all we know, good reasons.
  54. # We must work correctly in these cases. This includes "do not replace
  55. # target symlink with real directory" rule. So, no rm -rf here please.
  56. mkdir -p "$2/asm" 2>/dev/null
  57. mkdir -p "$2/asm-generic" 2>/dev/null
  58. mkdir -p "$2/linux" 2>/dev/null
  59. # Exists, but is not a dir? That's bad, bail out
  60. die_if_not_dir "$2/asm" "$2/asm-generic" "$2/linux"
  61. # cp -HL creates regular destination files even if sources are symlinks.
  62. # This is intended.
  63. # (NB: you need busybox 1.11.x for this. earlier ones are slightly buggy)
  64. cp -RHL "$KERNEL_HEADERS/asm"/* "$2/asm" || exit 1
  65. cp -RHL "$KERNEL_HEADERS/asm-generic"/* "$2/asm-generic" || exit 1
  66. cp -RHL "$KERNEL_HEADERS/linux"/* "$2/linux" || exit 1
  67. if ! test -f "$2/linux/version.h"; then
  68. echo "Warning: '$KERNEL_HEADERS/linux/version.h' is not found"
  69. echo "in kernel headers directory specified in .config."
  70. echo "Some programs won't like that. Consider fixing it by hand."
  71. fi
  72. # Fix mode/owner bits
  73. cd "$2" || exit 1
  74. chmod -R u=rwX,go=rX . >/dev/null 2>&1
  75. chown -R `id | sed 's/^uid=\([0-9]*\).*gid=\([0-9]*\).*$/\1:\2/'` . >/dev/null 2>&1